pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT > Class Template Reference
Module features

FPFHEstimationOMP estimates the Fast Point Feature Histogram (FPFH) descriptor for a given point cloud dataset containing points and normals, in parallel, using the OpenMP standard. More...

`#include <pcl/features/fpfh_omp.h>`

Inheritance diagram for pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >:

## Public Types

typedef boost::shared_ptr< FPFHEstimationOMP< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FPFHEstimationOMP< PointInT, PointNT, PointOutT > > | ConstPtr
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
Public Types inherited from pcl::FPFHEstimation< PointInT, PointNT, PointOutT >
typedef boost::shared_ptr< FPFHEstimation< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FPFHEstimation< PointInT, PointNT, PointOutT > > | ConstPtr
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| FPFHEstimationOMP (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
Public Member Functions inherited from pcl::FPFHEstimation< PointInT, PointNT, PointOutT >
| FPFHEstimation ()
| Empty constructor. More...
bool | computePairFeatures (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, int p_idx, int q_idx, float &f1, float &f2, float &f3, float &f4)
| Compute the 4-tuple representation containing the three angles and one distance between two points represented by Cartesian coordinates and normals. More...
void | computePointSPFHSignature (const pcl::PointCloud< PointInT > &cloud, const pcl::PointCloud< PointNT > &normals, int p_idx, int row, const std::vector< int > &indices, Eigen::MatrixXf &hist_f1, Eigen::MatrixXf &hist_f2, Eigen::MatrixXf &hist_f3)
| Estimate the SPFH (Simple Point Feature Histograms) individual signatures of the three angular (f1, f2, f3) features for a given point based on its spatial neighborhood of 3D points with normals. More...
void | weightPointSPFHSignature (const Eigen::MatrixXf &hist_f1, const Eigen::MatrixXf &hist_f2, const Eigen::MatrixXf &hist_f3, const std::vector< int > &indices, const std::vector< float > &dists, Eigen::VectorXf &fpfh_histogram)
| Weight the SPFH (Simple Point Feature Histograms) individual histograms to create the final FPFH (Fast Point Feature Histogram) for a given point based on its 3D spatial neighborhood. More...
void | setNrSubdivisions (int nr_bins_f1, int nr_bins_f2, int nr_bins_f3)
| Set the number of subdivisions for each angular feature interval. More...
void | getNrSubdivisions (int &nr_bins_f1, int &nr_bins_f2, int &nr_bins_f3)
| Get the number of subdivisions for each angular feature interval. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Public Attributes

int | nr_bins_f1_
| The number of subdivisions for each angular feature interval. More...
int | nr_bins_f2_
int | nr_bins_f3_

## Additional Inherited Members

Protected Member Functions inherited from pcl::FPFHEstimation< PointInT, PointNT, PointOutT >
void | computeSPFHSignatures (std::vector< int > &spf_hist_lookup, Eigen::MatrixXf &hist_f1, Eigen::MatrixXf &hist_f2, Eigen::MatrixXf &hist_f3)
| Estimate the set of all SPFH (Simple Point Feature Histograms) signatures for the input cloud. More...
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Attributes inherited from pcl::FPFHEstimation< PointInT, PointNT, PointOutT >
int | nr_bins_f1_
| The number of subdivisions for each angular feature interval. More...
int | nr_bins_f2_
int | nr_bins_f3_
Eigen::MatrixXf | hist_f1_
| Placeholder for the f1 histogram. More...
Eigen::MatrixXf | hist_f2_
| Placeholder for the f2 histogram. More...
Eigen::MatrixXf | hist_f3_
| Placeholder for the f3 histogram. More...
Eigen::VectorXf | fpfh_histogram_
| Placeholder for a point's FPFH signature. More...
float | d_pi_
| Float constant = 1.0 / (2.0 * M_PI) More...
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT>
class pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >

FPFHEstimationOMP estimates the Fast Point Feature Histogram (FPFH) descriptor for a given point cloud dataset containing points and normals, in parallel, using the OpenMP standard.

Note
  If you use this code in any academic work, please cite:

- R.B. Rusu, N. Blodow, M. Beetz. Fast Point Feature Histograms (FPFH) for 3D Registration. In Proceedings of the IEEE International Conference on Robotics and Automation (ICRA), Kobe, Japan, May 12-17 2009.
- R.B. Rusu, A. Holzbach, N. Blodow, M. Beetz. Fast Geometric Point Labeling using Conditional Random Fields. In Proceedings of the 22nd IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS), St. Louis, MO, USA, October 11-15 2009.

Attention
  The convention for FPFH features is:
  - if a query point's nearest neighbors cannot be estimated, the FPFH feature will be set to NaN (not a number)
  - it is impossible to estimate a FPFH descriptor for a point that doesn't have finite 3D coordinates. Therefore, any point that contains NaN data on x, y, or z, will have its FPFH feature property set to NaN.

Author
  Radu B. Rusu

Definition at line 75 of file fpfh_omp.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointNT , typename PointOutT >

typedef boost::shared_ptr<const FPFHEstimationOMP<PointInT, PointNT, PointOutT> > pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::ConstPtr

Definition at line 79 of file fpfh_omp.h.

## PointCloudOut

template<typename PointInT , typename PointNT , typename PointOutT >

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::PointCloudOut

Definition at line 93 of file fpfh_omp.h.

## Ptr

template<typename PointInT , typename PointNT , typename PointOutT >

typedef boost::shared_ptr<FPFHEstimationOMP<PointInT, PointNT, PointOutT> > pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::Ptr

Definition at line 78 of file fpfh_omp.h.

## Constructor & Destructor Documentation

## FPFHEstimationOMP()

template<typename PointInT , typename PointNT , typename PointOutT >

pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::FPFHEstimationOMP | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  [in] | nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 98 of file fpfh_omp.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## setNumberOfThreads()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  [in] | nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 107 of file fpfh_omp.h.

## Member Data Documentation

## nr_bins_f1_

template<typename PointInT , typename PointNT , typename PointOutT >

int pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::nr_bins_f1_

The number of subdivisions for each angular feature interval.

Definition at line 120 of file fpfh_omp.h.

## nr_bins_f2_

template<typename PointInT , typename PointNT , typename PointOutT >

int pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::nr_bins_f2_

Definition at line 120 of file fpfh_omp.h.

## nr_bins_f3_

template<typename PointInT , typename PointNT , typename PointOutT >

int pcl::FPFHEstimationOMP< PointInT, PointNT, PointOutT >::nr_bins_f3_

Definition at line 120 of file fpfh_omp.h.

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/fpfh_omp.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/impl/fpfh_omp.hpp